//
//  AnimationVIew.m
//  luftemd
//
//  Created by leon on 2017/11/1.
//  Copyright © 2017年 林柏显. All rights reserved.
//

/*************************** 获取屏幕 宽度、高度 ***************************/
#define SCREEN_WIDTH ([UIScreen mainScreen].bounds.size.width)
#define SCREEN_HEIGHT ([UIScreen mainScreen].bounds.size.height)
#define RGBA(a,b,c,d) [UIColor colorWithRed:a/255.0 green:b/255.0 blue:c/255.0 alpha:d]

#define WS(weakSelf)  __weak __typeof(&*self)weakSelf = self;

#import "AnimationView.h"
#import "MYFactoryManager.h"


@implementation AnimationView

+(instancetype)shanreAnimationView{
    
    static AnimationView * animationView = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        animationView =  [AnimationView new];
    });
    return animationView;
    
}

//-(void)startAnimation{
//    
//    self.animationView =  [UIView new];
//    self.animationView.frame = CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
//    self.animationView.backgroundColor = RGBA(76, 76, 76, 0.8);
//    [[UIApplication sharedApplication].keyWindow addSubview:self.animationView];
//    
//    //
//    self.imageView = [[UIImageView alloc] initWithFrame:CGRectMake((SCREEN_WIDTH - 90) / 2,(SCREEN_HEIGHT - 90) / 2, 90, 90)];
//    [self.animationView addSubview:self.imageView];
//    
//    if (self.imageView.isAnimating) return;
//    // 1.加载所有的动画图片
//    NSMutableArray *images = [NSMutableArray array];
//    
//    for (int i = 0 ; i<60; i++){
//        
//        NSString * filename = nil;
//        // 计算文件名
//        if (i < 10){
//            filename = [NSString stringWithFormat:@"linking000%d",i];
//        } else {
//            filename = [NSString stringWithFormat:@"linking00%d",i];
//        }
//        //        NSLog(@"filename = %@",filename);
//        UIImage *image = [UIImage imageNamed:filename];
//        // 添加图片到数组中
//        [images addObject:image];
//        
//    }
//    
//    self.imageView.animationImages = images;
//    // 2.设置播放次数(1次)
//    self.imageView.animationRepeatCount = 0;
//    // 3.设置播放时间
//    self.imageView.animationDuration = images.count * 0.1;
//    [self.imageView startAnimating];
//
//}
//
////label显示
//-(void)startAnimationWithAnimationLabel:(NSString*)title{
//    
//    //蒙层背景
//    self.animationView =  [UIView new];
//    self.animationView.frame = CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
//    self.animationView.backgroundColor = RGBA(76, 76, 76, 0.8);
//    [[UIApplication sharedApplication].keyWindow addSubview:self.animationView];
//        
//    //白底背景
//    self.backView = [[UIView alloc] initWithFrame:CGRectMake((SCREEN_WIDTH - 180) / 2,(SCREEN_HEIGHT - 180) / 2, 180, 180)];
//    self.backView.backgroundColor = [UIColor whiteColor];
//    [MYFactoryManager clipsToBoundsWithView:self.backView Radius:10];
//    [self.animationView addSubview:self.backView];
//    
//    //动画imageview
//    self.imageView = [[UIImageView alloc] initWithFrame:CGRectMake(30,10,120, 120)];
//    [self.backView addSubview:self.imageView];
//
//    if (self.imageView.isAnimating) return;
//    // 1.加载所有的动画图片
//    NSMutableArray *images = [NSMutableArray array];
//
//    for (int i = 0; i<60; i++){
//        NSString *filename = nil;
//        // 计算文件名
//        if (i < 10){
//            filename = [NSString stringWithFormat:@"linking000%d",i];
//        } else {
//            filename = [NSString stringWithFormat:@"linking00%d",i];
//        }
//        //        NSLog(@"filename = %@",filename);
//        UIImage *image = [UIImage imageNamed:filename];
//        // 添加图片到数组中
//        [images addObject:image];
//    }
//    self.imageView.animationImages = images;
//    // 2.设置播放次数(1次)
//    self.imageView.animationRepeatCount = 0;
//    // 3.设置播放时间
//    self.imageView.animationDuration = images.count * 0.1;
//    [self.imageView startAnimating];
//
//    //tip
//    self.animationLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 140,180, 40)];
//    self.animationLabel.text = title;
//    self.animationLabel.textColor = [UIColor whiteColor];
//    self.animationLabel.font = [UIFont systemFontOfSize:12];
//    self.animationLabel.textAlignment = NSTextAlignmentCenter;
//    self.animationLabel.backgroundColor = [UIColor whiteColor];
//    [self.backView addSubview:self.animationLabel];
//
//}
//
////倒计时按钮显示
//-(void)startAnimationWithCountButton{
//    
//    //蒙层背景
//    self.animationView =  [UIView new];
//    self.animationView.frame = CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
//    self.animationView.backgroundColor = RGBA(76, 76, 76, 0.8);
//    [[UIApplication sharedApplication].keyWindow addSubview:self.animationView];
//    
//    //白底背景
//    self.backView = [[UIView alloc] initWithFrame:CGRectMake((SCREEN_WIDTH - 180) / 2,(SCREEN_HEIGHT - 180) / 2, 180, 180)];
//    self.backView.backgroundColor = [UIColor whiteColor];
//    [MYFactoryManager clipsToBoundsWithView:self.backView Radius:10];
//    [self.animationView addSubview:self.backView];
//    
//    //动画imageview
//    self.imageView = [[UIImageView alloc] initWithFrame:CGRectMake(30,10,120, 120)];
//    [self.backView addSubview:self.imageView];
//    
//    if (self.imageView.isAnimating) return;
//    // 1.加载所有的动画图片
//    NSMutableArray *images = [NSMutableArray array];
//    
//    for (int i = 0; i<60; i++){
//        NSString *filename = nil;
//        // 计算文件名
//        if (i < 10){
//            filename = [NSString stringWithFormat:@"linking000%d",i];
//        } else {
//            filename = [NSString stringWithFormat:@"linking00%d",i];
//        }
//        //        NSLog(@"filename = %@",filename);
//        UIImage *image = [UIImage imageNamed:filename];
//        // 添加图片到数组中
//        [images addObject:image];
//    }
//    self.imageView.animationImages = images;
//    // 2.设置播放次数(1次)
//    self.imageView.animationRepeatCount = 0;
//    // 3.设置播放时间
//    self.imageView.animationDuration = images.count*0.1;
//    [self.imageView startAnimating];
//    
//    self.countButton = [UIButton buttonWithType:UIButtonTypeCustom];
//    self.countButton.frame = CGRectMake(0, 140,180, 40);
//    self.countButton.titleLabel.font = [UIFont systemFontOfSize:12];;
//    self.countButton.titleLabel.textAlignment = NSTextAlignmentCenter;
//    [self.countButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
//    self.countButton.backgroundColor = [UIColor whiteColor];
//    self.countButton.userInteractionEnabled = NO;
//    [self.backView addSubview:self.countButton];
//
//    __block int timeout = 59; //倒计时时间
//    dispatch_queue_t queue = dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0);
//    dispatch_source_t _timer = dispatch_source_create(DISPATCH_SOURCE_TYPE_TIMER, 0, 0,queue);
//    dispatch_source_set_timer(_timer,dispatch_walltime(NULL, 0),1.0*NSEC_PER_SEC, 0); //每秒执行
//    dispatch_source_set_event_handler(_timer, ^{
//        if(timeout<=0){ //倒计时结束，关闭
//            dispatch_source_cancel(_timer);
//            dispatch_async(dispatch_get_main_queue(), ^{
//
//            });
//        }else{
//            
//            int seconds = timeout % 60;
//            NSString *strTime = [NSString stringWithFormat:@"%.2d", seconds];
//            dispatch_async(dispatch_get_main_queue(), ^{
//                [self.countButton setTitle:[NSString stringWithFormat:@"%@%@s..",@"蓝牙连接丢失...",strTime] forState:UIControlStateNormal];
//            });
//            timeout--;
//        }
//    });
//    dispatch_resume(_timer);
//    
//}

-(void)stopAnimation{
    
//    if (self.imageView.isAnimating){
        
        [self.imageView stopAnimating];
        [self.animationView removeFromSuperview];
        [self.backView removeFromSuperview];
        [self.imageView removeFromSuperview];
        [self.animationLabel removeFromSuperview];
        [self.countButton removeFromSuperview];
        
//    }
    
    [self pauseLayer:self.imageView.layer];
    
}


//初始化小风扇动画
-(void)addAnimation{
    
    if (self.animationView!=nil){
        [self stopAnimation];
    }
    
    self.animationView =  [UIView new];
    self.animationView.frame = CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
    self.animationView.backgroundColor = RGBA(76, 76, 76, 0.8);
    [[UIApplication sharedApplication].keyWindow addSubview:self.animationView];
    
    //
    self.imageView = [[UIImageView alloc] initWithFrame:CGRectMake((SCREEN_WIDTH - 90) / 2,(SCREEN_HEIGHT - 90) / 2, 90, 90)];
    self.imageView.image = [UIImage imageNamed:@"loading"];
    [self.animationView addSubview:self.imageView];
    
    //tip
    self.animationLabel = [[UILabel alloc] initWithFrame:CGRectMake((SCREEN_WIDTH - 90) / 2, (SCREEN_HEIGHT - 90)/2+90+10,180, 40)];
//    self.animationLabel.text = @"链接鞋子...";
    self.animationLabel.textColor = [UIColor whiteColor];
    self.animationLabel.font = [UIFont systemFontOfSize:12];
    self.animationLabel.textAlignment = NSTextAlignmentCenter;
    self.animationLabel.backgroundColor = [UIColor clearColor];
    [self.animationView addSubview:self.animationLabel];
    
    //添加旋转动画
    _rotationAnimation = [self rotationDurTime:2 angle:360.f direction:-1 repeatCount:MAXFLOAT];
    _rotationAnimation.delegate = self;
    _rotationAnimation.removedOnCompletion = NO;
    [_rotationAnimation setRepeatCount:HUGE_VALF];
    _rotationAnimation.speed = 1;
    [self.imageView.layer addAnimation:self.rotationAnimation forKey:@"rotate"];
    
    WS(ws);
    //链接超时
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(15 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [ws stopAnimation];
    });
}

//暂停layer上面的动画
-(void)pauseLayer:(CALayer*)layer{
    
    CFTimeInterval pausedTime = [layer convertTime:CACurrentMediaTime() fromLayer:nil];
    layer.speed = 0.0;
    layer.timeOffset = pausedTime;
    
}

//周期时间 角度 方向 重复次数
-(CABasicAnimation *)rotationDurTime:(float)durTime angle:(float)angle direction:(int)direction repeatCount:(int)repeatCount{
    
    CABasicAnimation* animation  = [CABasicAnimation animationWithKeyPath:@"transform.rotation"];
//    animation.fromValue = [NSNumber numberWithFloat:0.f];
    animation.toValue = [NSNumber numberWithFloat:M_PI];
    animation.duration= durTime;
    animation.cumulative= YES;//是否累加
    animation.removedOnCompletion=NO;
    animation.fillMode =kCAFillModeForwards;
    animation.autoreverses = NO;//自动逆转
    animation.repeatCount = repeatCount;
    return animation;
    
}

@end
