//
//  TXCustomCollectionViewCell.m
//  slidetext
//
//  Created by 新华龙mac on 2018/1/16.
//  Copyright © 2018年 新华龙mac. All rights reserved.
//

#import "TXCarouselCollectionViewCell.h"

@interface TXCarouselCollectionViewCell()<UIGestureRecognizerDelegate>
@property (weak, nonatomic) IBOutlet UIImageView *imageView;
@property (weak, nonatomic) IBOutlet UILabel *titleStr;

@end

@implementation TXCarouselCollectionViewCell

- (void)awakeFromNib{
    
    [super awakeFromNib];
    
//    self.layer.shadowRadius = 6.0f;
//    self.layer.shadowColor = [UIColor blackColor].CGColor;
//    self.layer.shadowOpacity = 6.0f;
//    self.layer.shadowOffset = CGSizeMake(0, 0);
//    self.layer.masksToBounds = NO;
    
    self.covierView.layer.masksToBounds = YES;
    self.covierView.layer.borderColor = [UIColor whiteColor].CGColor;
    self.covierView.layer.borderWidth = 3;
    self.covierView.backgroundColor = [UIColor whiteColor];
    self.covierView.layer.cornerRadius = 15;
    
    self.imageView.layer.masksToBounds = YES;
    self.imageView.layer.cornerRadius = 70;
    
    //状态label
    NSMutableAttributedString *string = [[NSMutableAttributedString alloc] initWithString:@"在线" attributes:@{NSFontAttributeName: [UIFont fontWithName:@"PingFang SC" size: 12], NSForegroundColorAttributeName: [UIColor colorWithRed:0/255.0 green:220/255.0 blue:66/255.0 alpha:1.0]}];
    self.stateLable.attributedText = string;
    self.stateLable.textColor = [UIColor colorWithRed:0/255.0 green:220/255.0 blue:66/255.0 alpha:1.0];
    
}

/**
 解决手势冲突
 @param gestureRecognizer gestureRecognizer
 @param otherGestureRecognizer otherGestureRecognizer
 @return bool
 */
-(BOOL)gestureRecognizer:(UIGestureRecognizer*) gestureRecognizer shouldRecognizeSimultaneouslyWithGestureRecognizer:(UIGestureRecognizer*)otherGestureRecognizer{
    
    if ([gestureRecognizer.view isKindOfClass:[UICollectionView class]]){
        return NO;
    }else{
        return YES;
    }
    
}

/**
 手势滑动
 */
-(void)panSild{
    if (self.block) {self.block();}
}

/**
 加载数据

 @param model TXCarouselCellModel
 */
-(void)setCarouselCellModel:(TXCarouselCellModel *)model{
//    self.imageView.image = [UIImage imageNamed:model.imageUrl];
//    self.titleStr.text = model.titleStr;
}

-(void)setCusSelected:(BOOL)cusSelected{
   
    if (cusSelected == YES){
        
        self.covierView.layer.masksToBounds = YES;
        self.covierView.layer.borderColor = [UIColor colorWithRed:255/255.0 green:196/255.0 blue:0/255.0 alpha:1.0].CGColor;
        self.covierView.layer.borderWidth = 3;
        self.covierView.backgroundColor = [UIColor colorWithRed:255/255.0 green:245/255.0 blue:210/255.0 alpha:1.0];
        self.covierView.layer.cornerRadius = 15;

    }else{
        
        self.covierView.layer.masksToBounds = YES;
        self.covierView.layer.borderColor = [UIColor whiteColor].CGColor;
        self.covierView.layer.borderWidth = 3;
        self.covierView.backgroundColor = [UIColor whiteColor];
        self.covierView.layer.cornerRadius = 15;
             
    }
    
}
@end
