//
//  SearchDeviceViewController.h
//  Unity-iPhone
//
//  Created by leon on 2021/2/4.
//

#import <UIKit/UIKit.h>
#import "MYFactoryManager.h"

@interface SearchDeviceViewController : UIViewController


@property (strong, nonatomic)NSMutableArray  * deviceArray;  /**< 蓝牙设备个数 */

@property (strong,nonatomic)CBPeripheral * currentPeripheral;

@property (copy,nonatomic)void(^connectDeviceBlock)(CBPeripheral * peripheral);

@property (nonatomic, copy)void(^searchDeviceTask)();

//
-(void)reloadData;

-(void)getInteraction:(int)interaction;

@end

