//
//  UserFriendsModel.h
//  OYGameSKD
//
//  Created by leon on 2021/2/1.
//  Copyright © 2021 Oujia. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface UserFriendsModel : NSObject

@property (nonatomic, assign) int code;    //为0

@property (nonatomic, assign) int trans_id;    //业务id,避免关键字转换成非关键字
@property (nonatomic, assign) NSString * nickname;
@property (nonatomic, assign) NSString * avatar;
@property (nonatomic, assign) int  gender;
@property (nonatomic, assign) NSString * city;

@property (nonatomic, assign) NSString * status;//是否在线

@end


@interface RankModel : NSObject

//               "id":70,
//               "rank_id":5,
//               "game_id":3,
//               "user_id":144,
//               "score":8924,
//               "duration":349,
//               "consume":0,
//               "finish_at":"2021-09-06 09:54:09",
//               "rate_begin":"2021-09-01",
//               "rate_end":"2021-09-30",
//               "user_name":"用户不存在",
//               "user_avatar":"http://static.ouj.com/shoes/test/avatar/avatar_144_791469ce78a423b24a65e06921a1777a.jpg",
//               "user_level":3,
//               "user_gender":1,
//               "user_age":null,
//               "achievements":Array[13],
//               "achievements_show":Array[4],
//               "position":1

@property (nonatomic, assign) int trans_id;
@property (nonatomic, assign) int rank_id;
@property (nonatomic, assign) int game_id;
@property (nonatomic, assign) int user_id;
@property (nonatomic, assign) int score;
@property (nonatomic, assign) int duration;
@property (nonatomic, assign) int consume;

@property (nonatomic, assign) NSString * finish_at;
@property (nonatomic, assign) NSString * rate_begin;
@property (nonatomic, assign) NSString * rate_end;

@property (nonatomic, assign) NSString * user_name;
@property (nonatomic, assign) NSString * user_avatar;

@property (nonatomic, assign) int user_level;
@property (nonatomic, assign) int user_gender;
//@property (nonatomic, assign) int user_age;

@property (nonatomic, assign) NSArray * achievements;
@property (nonatomic, assign) NSArray * achievements_show;

@property (nonatomic, assign) int  position;



@end
