//
//  ShoesCarouselView.h
//  Unity-iPhone
//
//  Created by duowan123 on 2021/8/31.
//

#import <UIKit/UIKit.h>
#import <CoreBluetooth/CoreBluetooth.h>

#import "TXCarouselCellModel.h"

@protocol ConnectDeviceDelegate <NSObject>

-(void)connectDevice:(CBPeripheral*)peripheral;

@end

@interface ShoesCarouselView : UIView

@property(nonatomic,assign)id<ConnectDeviceDelegate> delegate;

/**
 配置数据（固定TXCarouselView）

 @param array TXCarouselCellModelArray
 */
//-(void)setArrayData:(NSArray <TXCarouselCellModel *>*)array;

/**
 配置数据（滑动TXCarouselView，加在ScrollViewv上时 需要传入）
 @param array TXCarouselCellModelArray
 @param superScrollView 父系ScrollView
 */
-(void)setArrayData:(NSArray <TXCarouselCellModel *>*)array;

-(void)yw_gotoNext:(NSInteger)index;


@end

