
#include "RunGame.h"

#include "pub.h"

void RunGame::Process(int* right_pos, int* right_att, int* right_acc, int right_zupt, int right_press,
	int* left_pos, int* left_att, int* left_acc, int left_zupt, int left_press,
	int jump, int down, int girl_shoes)
{
	/*
		ܿϷӿ,
		ʱͬһֿҽŵݣŻ
	*/

	if (left_zupt)
	{
		memcpy(left_last_pos, left_pos, 3 * sizeof(int));
	}

	if (right_zupt)
	{
		memcpy(right_last_pos, right_pos, 3 * sizeof(int));
	}

	int left_pos_tmp[3];
	int right_pos_tmp[3];

	for (int i = 0; i < 3; i++)
	{
		left_pos_tmp[i] = left_pos[i] - left_last_pos[i];
		right_pos_tmp[i] = right_pos[i] - right_last_pos[i];
	}
	/*
	if (left_zupt == 0)
	{
		std::cout << "rungame leftpos: " << left_pos_tmp[0] << " " << left_pos_tmp[1] << " " << left_pos_tmp[2] << std::endl;
	}
	
	if (right_zupt == 0)
	{
		std::cout << "rungame rightpos:  " << right_pos_tmp[0] << " " << right_pos_tmp[1] << " " << right_pos_tmp[2] << std::endl;
	}*/



	left_acc_status =  getAccStatus(left_zupt, left_acc, left_acc_max, left_acc_min);

	right_acc_status = getAccStatus(right_zupt, right_acc, right_acc_max, right_acc_min);
	
	setResultConLeft(left_zupt);

	result[0] = getResultLeft(left_pos_tmp, girl_shoes);

	setResultConRight(right_zupt);
	
	result[1] = getResultRight(right_pos_tmp, girl_shoes);

	result[2] = getResultJump(jump);

	result[3] = getResultDown(down);

}

void RunGame::getResult(int* dec)
{
	memcpy(dec, result, 4 * sizeof(int));
}

void RunGame::setResultConLeft(int zupt)
{
	if (zupt == 1)
	{
		left_has_result = 1;
		left_pos_offset_min = 0;
	}

}

void RunGame::setResultConRight(int zupt)
{
	if (zupt == 1)
	{
		right_has_result = 1;
		right_pos_offset_min = 0;
	}
}

int RunGame::getAccStatus(int zupt, int* acc, int* max_acc, int* min_acc)
{
	/*
	* ϷԵʱҷɵԼüٶȹһ
	* Ƕʽ޸
	*/
	if (zupt)
	{
		memcpy(max_acc, acc, 3 * sizeof(int));
		memcpy(min_acc, acc, 3 * sizeof(int));
	}
	else
	{
		for (int i = 0; i < 3; i++)
		{
			if (max_acc[i] < acc[i])
			{
				max_acc[i] = acc[i];
			}

			if (min_acc[i] > acc[i])
			{
				min_acc[i] = acc[i];
			}
		}
	}

	for (int i = 0; i < 3; i++)
	{
		if (max_acc[i] - min_acc[i] > 1024)
		{
			return 1;
		}
	}

	return 0;
}


int RunGame::getResultLeft(int *pos, int girl_shoes)
{
	int isLeft = -1;

	int distance_threshold = 20;

	if (girl_shoes)
		distance_threshold = 15;

	if (pos[0] > left_pos_offset_min)
	{
		left_pos_offset_min = pos[0];

	}

	if (left_has_result == 1 && pos[0] - left_pos_offset_min < -distance_threshold)
	{
		printf("this motion is Left\n");
		isLeft = MOTION_LEFT;
		left_has_result = 0;
	}
	else if (left_has_result == 1 && pos[0] - left_pos_offset_min < -distance_threshold && left_acc_status == 0)
	{
		std::cout << "appear error command on zero_vel status (left_foot) " << endl;

	}

	return isLeft;
}

int RunGame::getResultRight(int *pos, int girl_shoes)
{
	int isRight = -1;

	int distance_threshold = 20;

	if (girl_shoes)
	{
		distance_threshold = 15;
	}
	if (pos[0] < right_pos_offset_min)
	{
		right_pos_offset_min = pos[0];
	}

	if (right_has_result == 1 && pos[0] - right_pos_offset_min > distance_threshold)
	{
		printf("this motion is Right\n");

		isRight = MOTION_RIGHT;
		right_has_result = 0;
	}
	else if (right_has_result == 1 && pos[0] - right_pos_offset_min > distance_threshold && right_acc_status == 0)
	{
		std::cout << "appear error command on zero_vel status (right_foot) " << endl;

	}

	return isRight;
}

int RunGame::getResultLeftRight(int* pos, int devNum)
{
	if (devNum == LEFT_FOOT && pos[1] < 0)
	{
		return MOTION_LEFT;
	}

	if (devNum == RIGHT_FOOT && pos[1] > 0)
	{
		return MOTION_RIGHT;
	}

	return -1;
}

int RunGame::getResultJump(int jump)
{
	int isJump = -1;

	last_jump_time++;

	if (last_jump == 0 && jump == 1 && left_acc_status == 1 && right_acc_status == 1)
	{
		static int jump_count = 0;

		printf("this motion is Jump : %d\n", jump_count++);

		isJump = MOTION_JUMP;

		last_jump_time = 0;
	}
	else
	{
		if (last_jump == 0 && jump == 1 && !(left_acc_status == 1 && right_acc_status == 1))
		{
			std::cout << "appear error command on zero_vel status (jump command) " << endl;
		}
	}

	last_jump = jump;

	return isJump;
}

int RunGame::getResultDown(int down)
{
	int isDown = -1;
	
	if (last_down == 0 && down == 1 && last_jump_time > 10)
	{
		printf("this motion is Down\n");
		isDown = MOTION_DOWN;
	}

	last_down = down;

	return isDown;

}

RunGame::RunGame()
{
	last_down = 0;
	last_jump = 0;

	last_jump_time = 0;

	left_has_result = 0;
	right_has_result = 0;

	left_zupt = 0;
	right_zupt = 0;

	left_pos_offset_min = 0;
	right_pos_offset_min = 0;

	memset(result, 0, 4 * sizeof(int));

	memset(left_last_pos, 0, 3 * sizeof(int));
	memset(right_last_pos, 0, 3 * sizeof(int));

}
